//
//  FlowMonitor.m
//  IDLExplorer
//
//  Created by Victor on 5/24/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "FlowMonitor.h"
#import <ADORB/ADORB.h>

@implementation FlowMonitor

static unsigned myComponentTag = 0x00110101;

+ (void) initialize
{
	if([FlowMonitor class] == self)
		[IDLTaggedComponent registerComponentTag:myComponentTag withIDLPath:@"ORBVersion/Version"];
}

- init
{
	self = [super init];
	_data = [[NSMutableDictionary alloc]init];
	[[ORB notificationCenter] addObserver:self
		selector:@selector(setObjectProfile:) name:ORBDidCreateObjectProfile object:nil];
	[[ORB notificationCenter] addObserver:self
		selector:@selector(sendRequest:) name:ORBWillSendRequest object:nil];
	[[ORB notificationCenter] addObserver:self
		selector:@selector(receiveReply:) name:ORBDidReceiveResponse object:nil];
	[[ORB notificationCenter] addObserver:self
		selector:@selector(receiveException:) name:ORBDidReceiveException object:nil];
	[[ORB notificationCenter] addObserver:self
		selector:@selector(receiveOther:) name:ORBDidReceiveOther object:nil];
		
	return self;
}

- (void) dealloc
{
	[[ORB notificationCenter]removeObserver:self];
	[super dealloc];
}

- (void) setObjectProfile:(NSNotification*)note
{
	NSDictionary* version = [NSDictionary dictionaryWithObjectsAndKeys:
		[NSNumber numberWithUnsignedLong:1], @"major",
		[NSNumber numberWithUnsignedLong:5], @"minor", nil];
	IDLTaggedComponent* component = [[[IDLTaggedComponent alloc]initWithTag:myComponentTag component:version]autorelease];
	[[note object]addTaggedComponent:component];
}

- (void) sendRequest:(NSNotification*)note
{
	NSDictionary* info = [note userInfo];
	id requestId = [info objectForKey:ORBRequestIdKey];
	[_data setObject:[NSDate date] forKey:requestId];
}

- (void) receiveReply:(NSNotification*)note
{
	NSDictionary* info = [note userInfo];
	id requestId = [info objectForKey:ORBRequestIdKey];
	NSDate* date = [_data objectForKey:requestId];
	if(date){
		NSTimeInterval t = [[NSDate date]timeIntervalSinceDate:date];
		NSLog(@"+ %@ - %0.3f sec", [info objectForKey:ORBOperationNameKey], t);
	}
	[_data removeObjectForKey:requestId];
}

- (void) receiveException:(NSNotification*)note
{
	NSDictionary* info = [note userInfo];
	id requestId = [info objectForKey:ORBRequestIdKey];
	NSDate* date = [_data objectForKey:requestId];
	if(date){
		NSTimeInterval t = [[NSDate date]timeIntervalSinceDate:date];
		NSLog(@"* %@ - %0.3f sec", [info objectForKey:ORBOperationNameKey], t);
	}
	[_data removeObjectForKey:requestId];
}

- (void) receiveOther:(NSNotification*)note
{
	NSDictionary* info = [note userInfo];
	id requestId = [info objectForKey:ORBRequestIdKey];
	NSDate* date = [_data objectForKey:requestId];
	if(date){
		NSTimeInterval t = [[NSDate date]timeIntervalSinceDate:date];
		NSLog(@"# %@ - %0.3f sec", [info objectForKey:ORBOperationNameKey], t);
	}
	[_data removeObjectForKey:requestId];
}

@end
